//@author: Martin Zrcek
//@help: Outputs X positions for Y line of pixels. Should be used with filterOneSideLine
//@tags:
//@credits:

// --------------------------------------------------------------------------------------------------
// PARAMETERS:
// --------------------------------------------------------------------------------------------------
float4x4 tW: WORLD;
int timesToScan=50;
float maximum=0.0;
float xTransform=1.0;
texture Tex <string uiname="Texture";>;
sampler Samp = sampler_state    //sampler for doing the texture-lookup
{
    Texture   = (Tex);          //apply a texture to the sampler
    MipFilter = LINEAR;         //sampler states
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};
//float4x4 tTex: TEXTUREMATRIX <string uiname="Texture Transform";>;

struct vs2ps
{
    float4 Pos  : POSITION;
    float2 TexCd : TEXCOORD0;
};

// --------------------------------------------------------------------------------------------------
// VERTEXSHADERS
// --------------------------------------------------------------------------------------------------
vs2ps VS(
    float4 PosO  : POSITION,
    float4 TexCd : TEXCOORD0)
{
    //declare output struct
    vs2ps Out;

    //transform position
	PosO.xy*=2.0;
    Out.Pos = PosO;
    //TexCd.x=1.0-TexCd.x;
    //transform texturecoordinates
//    Out.TexCd = mul(TexCd, tTex);
    Out.TexCd = TexCd;

    return Out;
}

// --------------------------------------------------------------------------------------------------
// PIXELSHADERS:
// --------------------------------------------------------------------------------------------------

float4 PS(vs2ps In): COLOR
{
    float4 col = 1.0;
	for (int i=0; i<timesToScan; i++) {
		float part = i*1.0/timesToScan;
		col = tex2D(Samp, float2(.5+xTransform*part/2.0,In.TexCd.y));
		if (col.r>maximum) maximum=part ;
	}
	col.xyz=maximum;
	col.a=1.0;
	//if (In.TexCd.y>.5) col.r=0.0;
    return col;
}

// --------------------------------------------------------------------------------------------------
// TECHNIQUES:
// --------------------------------------------------------------------------------------------------

technique TSimpleShader
{
    pass P0
    {
        //Wrap0 = U;  // useful when mesh is round like a sphere
        VertexShader = compile vs_3_0 VS();
        PixelShader  = compile ps_3_0 PS();
    }
}